% !TeX spellcheck = en_US
\graphicspath{{src/part02_mesh_moving_methods/img/}}

\section{Mesh Moving Methods}
\begin{frame}[plain,noframenumbering]
    \begin{centering}
        \hfill
        \begin{beamercolorbox}[rounded=true,center,sep=0.2em,wd=0.6\textwidth]{frametitle}
            \Huge Mesh Moving Methods
        \end{beamercolorbox}
        \hfill
    \end{centering}
\end{frame}


%
% Breve reseña historica
%

\begin{frame}{Historial review}
    
    \begin{columns}
        \column[t]{0.4\textwidth}
        \begin{block}{Local methods}
            \begin{itemize}
                \item linear springs along edges
                \item predictor-corrector schemes
                \item torsional springs
                \item semi-torsional springs
            \end{itemize}
        \end{block}
    
        \column[t]{0.45\textwidth}
        \begin{block}{Variational methods}
            \begin{itemize}
                \item Thermal problems
                \item Optimization problems
                \item \textbf{Pseudo-linear elasticity equations}
                \item Finite strains
                \item Mesh relaxation
            \end{itemize}
        \end{block}
    \end{columns}

\end{frame}


\subsection{MJBS}
\begin{frame}{Mesh Moving Methods}
    
    \begin{center}
        \Large
        \textit{Mesh Jacobian-Based Method} (MJBS)
    \end{center}
    
    
    \begin{center}
    \begin{columns}
        
        \column[t]{0.4\textwidth}\vspace{-0.5em}
        \begin{block}{Pseudo-elastic mechanical problem}\vspace{-1.5em}
            \begin{equation*}
            \int_{\Omega_{\tilde{t}}} \Gradsym(\viru) \cdot \Sigma^{\u} \left( \frac{J^{R}}{J^{M}} \right)^{\chi} d\Omega = 0 \quad \forall \viru \in \text{Var}_{\u}
            \end{equation*}
            
            \begin{itemize}
                \item $\Sigma^\u = \lambda \, \text{tr}(\Gradsym(\u)) \, \mathbf{I} + 2\mu \, \Gradsym(\u)$
                \item $\chi$ stiffening power
                \item $J^{M} = \text{det}\left(\pder{\x_{\tilde{t}}}{\boldsymbol{\xi}} \right)$
                \item $\x_{\tilde{t}} = \mathcal{A}(\x_0,\tilde{t})$
                \item $J^R$: global scaling value
                \item $\boldsymbol{\xi}$: parametric coordinates
                \item $\mathcal{A}$: ALE mapping
            \end{itemize}
            
            
        \end{block}
        
        \column[t]{0.6\textwidth}
        \begin{block}{}
            \centering
            \includegraphics[width=0.9\textwidth]{mjbs_kinematic_setting.pdf}
        \end{block}

    \end{columns}
    \end{center}
    
    
\end{frame}

\subsection{BIMO}    
\begin{frame}{Mesh Moving Methods}
    \begin{center}
        \Large
        \textit{Biologically-Inspired Mesh Optimizer} (BIMO)\blfootnote{\textit{Biocca et al., Comput. Mech., 2021, A biologically-inspired mesh optimizer based on pseudo-material remodeling. DOI: \href{https://doi.org/10.1007/s00466-021-02101-6}{10.1007/s00466-021-02101-6}}.}
    \end{center}
    %\pause

    \begin{block}{Main aspects}
        %\setbeamercovered{transparent}
%        \begin{itemize}
%            \item<alert@+> \textit{framework} mecanobiológico
%            \item<alert@+> Múltiples configuraciones libres de tensión para cada constituyente
%            \item<alert@+> Procesos de G\&R para relajación de mallas
%            \item<alert@+> Mecanismos de reclutamiento de fibras
%            \item<alert@+> Fuerzas nodales no proporcionales al tamaño de los elementos
%            \item<alert@+> Un método de optimización y movimiento simultáneo de mallas.
%        \end{itemize}
        \begin{itemize}
%            \item \textit{framework} mecanobiológico
%            \item Múltiples configuraciones libres de tensión para cada constituyente
%            \item Procesos de G\&R para relajación de mallas
%            \item Mecanismos de reclutamiento de fibras
%            \item Fuerzas nodales no proporcionales al tamaño de los elementos
%            \item Un método de optimización y movimiento simultáneo de mallas.
            %
            \item Mechanobiological framework
            \item Flexible stress-free configurations for both consituents
            \item Fiber recruitment mechanisms
            \item Nodal forces not proportional to element sizes
            \item A simultaneous mesh optimization and moving method
        \end{itemize}
    \end{block}

\end{frame}


\subsubsection{Kinematics}
\begin{frame}<5>{Mesh Moving Methods - BIMO}
    
    \vspace{-1.3em}
    \begin{columns}
        \column[t]{0.55\textwidth}
        \begin{block}<1->{Kinematics}\vspace{0.4em}
            \centering
            \includegraphics[width=1.0\textwidth]{bimo_kinematic_setting.pdf}
        \end{block}
        \vspace{-1em}
        \begin{block}<5->{Principle of Virtual Power}\vspace{-1.8em}
            \begin{equation*}
                \int_{\Omega_{s}} \left( \Sigma_g^\u + \Sigma_f^{\u+\v} \right) \cdot \Gradsym(\viru) \, d\Omega = 0 \quad \forall \viru \in \text{Var}_{0}
            \end{equation*}
        \end{block}
        
        \column[t]{0.45\textwidth}
%        \begin{block}{Principio PPV}
%            \begin{equation*}
%                \int_{\Omega_{s}}
%            \end{equation*}
%        \end{block}
        {
        \setbeamercovered{transparent}
        \begin{block}{}
            \begin{itemize}
                \item<2-> $\Omega_{0}$ ZSS $\rightarrow$ ground
                \item<2-> $\Omega_{v}$ ZSS $\rightarrow$ fiber tissue
                \item<2-> $\Omega_{s}$ self-equilibrium configuration
                \item[]
                \item<3-> $d\x_s = \F^{\u} d\x_0$
                \item<3-> $d\x_0 = \F^{\v} d\x_v$
                \item<3-> $d\x_s = \F^{\u\v} d\x_v$, siendo $\F^{\u\v} = \F^\u \F^\v$
                \item[]
                \item<4-> $\Sigma_g^\u = \frac{1}{\det\F^\u} {\F^\u}^T \S_g(\E^\u) \F^\u$
                \item<4-> $\Sigma_f^{\u+\v} = \frac{1}{\det\F^{\u\v}} {\F^{\u\v}}^T \S_f(\E^{\u\v}) \F^{\u\v}$
            \end{itemize}
        \end{block}
        }
    \end{columns}
\end{frame}
    
\subsubsection{Virtual Configuration}
\begin{frame}{BIMO - Virtual configuration}
    \vspace{-1em}
    \begin{block}{Building process}\vspace{0.5em}
        \centering
        \includegraphics[width=0.55\textwidth]{virtual_configuration_assembly.pdf}
    \end{block}
    

    \begin{itemize}
        \item $\Omega_v^e$ is defined as the regular simplex such that both $\Omega_v^e$ and its initial counterpart $\Omega_0^e$ have the same mean edge length
        \item $\Omega_v$ $\rightarrow$ incompatible configuration
    \end{itemize}
\end{frame}

\subsubsection{Consitutive Model}
\begin{frame}{BIMO - Constitutive model}
    
    \vspace{-1.5em}
    
    \begin{columns}
        
        \column[c]{0.35\textwidth}
        \begin{block}{}
            \centering
            \includegraphics[height=0.675\textheight]{fiber_recruitment.pdf}
        \end{block}
        
        \column[c]{0.20\textwidth}
        \begin{block}{}
            \begin{empheq}[box=\ovalbox]{equation*}
            \lambda = \sqrt{\mathbf{a}_v^i \cdot \bar{\mathbf{C}}^{\u\v} \mathbf{a}_v^i}
            \end{empheq}
        \end{block}
        
        
        \column[c]{0.35\textwidth}
        \begin{block}{}
            \centering
            \includegraphics[angle=0,height=0.65\textheight]{fiber_recruitment_individual.pdf}
        \end{block}
    \end{columns}
    
    \vspace{-1em}
    \begin{center}
    \begin{minipage}{1.0\textwidth}
        \begin{columns}
            \column[t]{0.40\textwidth}
            \begin{block}{Ground tissue} \vspace{-2em}
                \begin{equation*}
                \Psi_g = k_g \left( I_1^{\mathbf{u}} - 3\right), \quad \S_g = \left. \pder{\Psi_g}{\E} \right\vert_{\E=\E^{\u}}
                \end{equation*}
            \end{block}
            
            \column[t]{0.6\textwidth}
            \begin{block}{Fiber tissue}\vspace{-2.25em}
                \begin{equation*}
                    \Psi_f = \sum_{i=1}^{N} \frac{k_{1}^{i}}{2 k_{2}^{i}} \left( e^{k_{2}^{i} \left( (\bar{\lambda}_{e}^{i})^{2} - 1 \right)} - 1\right),
                    \quad
                    \S_f = \left. \pder{\Psi_f}{\E} \right\vert_{\E=\E^{\u\v}}
                \end{equation*}
            \end{block}
            
        \end{columns}
    \end{minipage}
    \end{center}
    
\end{frame}

\subsubsection{Fiber Recruitment}
\begin{frame}{Fiber recruitment}
 

    \begin{columns}
        
        \column[]{0.45\textwidth}
        \begin{figure}
            \centering
            \includegraphics[width=1.0\textwidth]{fiber_recruitment_model_a_elastic_fiber_stretch.pdf}
        \end{figure}
        
        \column[]{0.1\textwidth}
        \begin{empheq}[box=\ovalbox]{equation*}
            \lambda_e = \frac{\lambda}{\lambda_R}
        \end{empheq}
        
        \column[]{0.45\textwidth}
        \begin{figure}
            \centering
            \includegraphics[width=1.0\textwidth]{fiber_recruitment_model_b_fiber_recruitment.pdf}
        \end{figure}
    \end{columns}


\setbeamercovered{transparent}
\setlength{\leftmargini}{0em}
    %\begin{center}
    \begin{minipage}{0.9\textwidth}
        \begin{block}{Material design}\vspace{0em}
            \begin{columns}
                %\hspace{1em}
                \column[]{0.275\textwidth}
                \begin{itemize}
                    \item bounded elastic stretch 
                    \item bounded stresses
                \end{itemize}
                
                \column[]{0.5\textwidth}
                \begin{itemize}
                    \item Adaptive fiber recruitment $\lambda_R^i$
                    \item Bidirectional mechanical response
                \end{itemize}
            \end{columns}
        \end{block}
    \end{minipage}
    %\end{center}

    
\end{frame}

\subsubsection{Element-based stiffening}
\begin{frame}{Element-based stiffening}
    
    \begin{block}{MJBS strategy -- \textit{Stiffening power} $\chi$ selection}\vspace{0em}
        
        \begin{columns}
            \column[]{0.55\textwidth}
            \begin{equation*}
            \int_{\Omega_{s}} \boldsymbol{\sigma} \cdot \boldsymbol{\varepsilon}(\hat{\mathbf{u}}) \, d\Omega
            \rightarrow
            \int_{\Omega_{s}} \boldsymbol{\sigma} \cdot \boldsymbol{\varepsilon}(\hat{\mathbf{u}}) \left( \frac{J^R}{J^{M}} \right)^{\chi} d\Omega
            \end{equation*}    
            
            \column[]{0.45\textwidth}
            {%
            \small%\color{red}
            Several options arise from the value of $\chi$ adopted. Usually, $\chi \in \left[0,2\right]$ 
            %Según el valor adoptado para $\chi$ surgen distintas opciones. Normalmente, $\chi \in \left[0,2\right]$
            }
            
            
        \end{columns}
        
    \end{block}
    
    \begin{block}{BIMO strategy -- $\chi$ selection} \vspace{-1em}
        
        \begin{columns}
            \column[]{0.3\textwidth}
            \begin{figure}
                \centering
                \includegraphics[width=0.8\textwidth]{element-based_stiffening_diagram.pdf}
            \end{figure}
            
            \column[]{0.7\textwidth}
            
            \begin{equation*}
            \int_{\Omega_{s}} \boldsymbol{\sigma}^h \cdot \boldsymbol{\varepsilon}(\hat{\mathbf{u}}^h) \left( \frac{J^R}{J^{M,h}} \right)^{\chi} d\Omega
            =
            \sum_e \int_{\Omega_{s}^e} \boldsymbol{\sigma}_e \cdot \underbrace{\boldsymbol{\varepsilon}(\Psi_I \hat{\mathbf{e}}_r)_e \left( \frac{J^R}{J^{M}_e} \right)^{\chi} d\Omega}_{\mathcal{O}(1)}
            \end{equation*}
            %(\Psi_I \hat{\mathbf{e}}_r)_e
            
            
            \begin{equation*}
            \left.
            \begin{aligned}
            \boldsymbol{\varepsilon}(\Psi_I \hat{\mathbf{e}}_r)_e &\sim h^{-1} \\
            (J^{M}_e)^{-\chi} &\sim h^{-\chi h} \\
            \lvert \Omega_s^e \rvert &\sim h^d
            \end{aligned}
            \right\}
            \rightarrow
            \chi = 1 - \frac{1}{d}
            \end{equation*}
            
        \end{columns}
        
    \end{block}    
    
\end{frame}

\begin{frame}{Pseudo-material remodeling}
    
    
    \vspace{-0.5cm}
    \begin{columns}
        \column[]{0.60\textwidth}
        \begin{figure}
            \centering
            \includegraphics[width=0.8\textwidth]{bimo_kinematic_setting_remodeling.pdf}
        \end{figure}
        
        \column[]{0.40\textwidth}
        
        \begin{block}{Remodeling Algorithm}
            
            
            {\normalsize
                %\setbeamertemplate{itemize/enumerate subbody begin}{\tiny}
                %\setlength{\algomargin}{-2em}
                \SetCustomAlgoRuledWidth{0.8\textwidth}
                \scalebox{1.0}{
                    \begin{algorithm}[H]%\label{alg:remodeling}
                        Loop pseudo-time ($\tau$)
                        \begin{itemize} 
                            %\setlength{\itemindent}{-2em}
                            \item[] Loop mechanical problem
                            \item[] Remodeling:
                            \begin{itemize}
                                %\setlength{\itemindent}{-2em}
                                \vspace{-0.5em}
                                \item[-] \textit{ground}, $\Omega_{t_n} \rightarrow \Omega_{t_{n+1}}$
                                \item[-] fiber, $\Omega_{v_{n}} \rightarrow \Omega_{v_{n+1}}$
                            \end{itemize}
                            \item[] Convergence on $\mathbf{u}_{n+1}$
                        \end{itemize}
                        %\caption{Remodeling algorithm.}
                    \end{algorithm}
                }
            }
            
        \end{block}
    \end{columns}

    \vspace{-1em}
    \begin{block}{}
        \begin{equation*} \label{eq:mesh_moving_methods.bimo.equilibrium_at_spatial_with_remodeling}
        \int_{\Omega_{t_{n+1}}} \hspace{-1.25em} \left( \Sigma_g^{\u_{n+1}} + \Sigma_f^{\v_{n} + \u_{n+1}}  \right) \cdot \Gradsym(\viru_{n+1}) \left( \frac{J^R}{J^M_{n+1}} \right)^{\chi} d\Omega = 0 \quad \forall \viru_{n+1} \in \text{Var}_{\u_{n+1}}
        \end{equation*}
    \end{block}
    

\end{frame}